﻿local gtt = GameTooltip;
local cache={};
local CACHESIZE=50;


-- HOOK: OnTooltipSetUnit
gtt:HookScript("OnTooltipSetUnit",function(self,...)
	-- Get the unit -- Check the UnitFrame unit if this tip is from a concatenated unit, such as "targettarget".
	local _, unit = self:GetUnit();
	if (not unit) then
		local mFocus = GetMouseFocus();
		if (mFocus) and (mFocus.unit) then
			unit = mFocus.unit;
		end
	end
	-- No Unit or not a Player
	if (not unit) or (not UnitIsPlayer(unit)) then
		return;
	end

	local GuildName = GetGuildInfo(unit);
	if not(GuildName == nil) then
		local regionTable = { "US", "KR", "EU", "TW", "CN" }
		local regionKey = _G["GetCurrentRegion"] and regionTable[GetCurrentRegion()] or string.sub(GetCVar("realmList"), 1, 2):upper()
		local Locale = regionKey
--		local Locale = string.upper(string.sub(GetCVar("realmList"),1,2));

		local pname,rname = UnitName(unit);
		if rname==nil then
			rname=string.sub(GetRealmName(),1,3)..string.sub(GetRealmName(),-3);
		else
			rname=string.sub(rname,1,3)..string.sub(rname,-3);
		end
		
		-- self:AddLine( "Guild Info:|cffffffff "..GuildName..rname..Locale );

		local found=0;

		-- Check cache for entry

		local searchname=GuildName..rname..Locale;

		for i=1,#cache do
			if cache[i]["n"]==searchname then
				if cache[i]["w"]==0 then
--					self:AddLine( "GuildOx "..CHANNEL_CATEGORY_WORLD.." "..RANK..":|c77777777 >"..#worldranks-1);
				else
					self:AddLine( "GuildOx "..CHANNEL_CATEGORY_WORLD.." "..RANK..":|cffffffff ".." "..cache[i]["w"].." ("..cache[i]["r"]..") ["..cache[i]["p"].."]");
				end
				found=1;
				break;
			end
		end

		-- Not cached
		if found==0 then
			realmcount=0;
			for i=1,#worldranks-1 do
				if string.sub(worldranks[i],-8)==rname..Locale then
					realmcount=realmcount+1;
				end
				if worldranks[i]==searchname then
					self:AddLine( "GuildOx "..CHANNEL_CATEGORY_WORLD.." ".." "..RANK..":|cffffffff ".." "..i.." ("..realmcount..") ["..progress[i].."]");
					found=1;
					nextindex=#cache+1;
					cache[nextindex]={};
					cache[nextindex]["n"]=searchname;
					cache[nextindex]["w"]=i;
					cache[nextindex]["r"]=realmcount;
					cache[nextindex]["p"]=progress[i];
					break;
				end
			end
		end

		-- Guild not found
		if found==0 then
--			self:AddLine( "GuildOx "..CHANNEL_CATEGORY_WORLD.." "..RANK..":|c77777777 >"..#worldranks-1);
			nextindex=#cache+1;
			cache[nextindex]={};
			cache[nextindex]["n"]=searchname;
			cache[nextindex]["w"]=0;
			cache[nextindex]["r"]=0;
			cache[nextindex]["p"]="";
		end

		if #cache>CACHESIZE then
			tremove(cache,1);
		end
	end
end);